package bagliliste;

public class baglantiliListe {

    private Dugum bas;
    private Dugum son;
    private int elemanSayisi;

    public baglantiliListe() {
        bas = son = null;
        elemanSayisi = 0;
    }

    public void add(int poz, int e) {

        if (poz < 0 || poz > elemanSayisi) {
            System.out.println(poz +". pozisyona "+e+" değeri ekleme işleminiz tamamlanamadı. "
                    + "Girilen pozisyon değeri geçersiz."
                    + "(Girilebilecek maksimum pozisyon değeri : "+elemanSayisi+ ")");
            return;
        }

        Dugum temp = new Dugum();
        temp.veri = e;
        temp.sonraki = null;

        // başa ekleme
        if (poz == 0) {
            temp.sonraki = bas;
            bas = temp;
            if (son == null) {
                son = temp;
            }

            // sona ekleme
        } else if (poz == elemanSayisi) {
            if (son != null) {
                son.sonraki = temp;
                son = temp;
            } else {
                bas = temp;
                //son = temp;
            }
            // ortaya ekleme
        } else {
            Dugum p = bas;
            for (int i = 1; i < poz; i++) {
                p = p.sonraki;
            }

            temp.sonraki = p.sonraki;
            p.sonraki = temp;
        }

        elemanSayisi++;
    }

    public int indexOf(int e) {

        Dugum p = bas;
        for (int i = 0; i < elemanSayisi; i++) {
            if (p.veri == e) {
                return i;
            }
            p = p.sonraki;
        }

        return -1;
    }

    public boolean isEmpty() {
        if (elemanSayisi == 0) {
            return true;
        } else {
            return false;
        }
    }

    public int last() {
        return son.veri;
    }

    public int first() {
        return bas.veri;
    }

    public int size() {
        return elemanSayisi;
    }

    public int get(int poz) {
        Dugum p = bas;
        for (int i = 0; i < elemanSayisi; i++) {
            if (poz == i) {
                return p.veri;
            } else {
                p = p.sonraki;
            }
        }


        return 0;
    }

    public void print() {
        Dugum p = bas;

        for (; p != null; p = p.sonraki) {
            System.out.print(p.veri + " ");
        }
    }


}
